


#include <stdlib.mqh>

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern   bool     EcnBroker     = true;
extern   bool     TradeInside   = false;    // Trading inside Trendlines  : Bouncing Trade
extern   bool     TradeOutside  = true;    // Trading outside Trendlines : Breaking Trade
extern   string   UpperLineName = "Upperline";
extern   string   LowerLineName = "Lowerline";
extern   double   LotSize       = 0.1;
extern   double   TakeProfit    = 50;
extern   double   StopLoss      = 30;
extern   double   Pipaway       = 3; 
extern   double   Piplimit      = 10;       
extern   int      Slippage      = 3;
extern   bool     UseAutoMagic  = true;
extern   int      ManualMagic   = 20090206;
extern   bool     ShowAlerts    = false;
extern   string   EAcomment     = "";
extern   bool     ScreenDisplay = true;
extern   double   lTrailingStop = 20;
extern   double   sTrailingStop = 20;

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

double   point = 1; 
string   strtmp, sig;
int      myBars;
double   upper, prevupper, lower, prevlower, openprice;
string   s_symbol;

int      Magic;
int      digit;


// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   s_symbol = Symbol();
  
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) point = 1;
   if (digit==3 || digit==5) point = 10;
   if (digit==6)             point = 100;
  
   if (UseAutoMagic) Magic = GetMagic();
   else              Magic = ManualMagic;  
   
   sig="N/A";      
   Comment("");
   return(0);    
}

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
{
   Comment("");
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //



int start()
{

   // Check for Trendline 
   // ============================================
   
   if (ObjectFind(UpperLineName)<0) upper = -1;
   else {
      upper     = ObjectGetValueByShift(UpperLineName,1);
      prevupper = ObjectGetValueByShift(UpperLineName,2);
   }
   
   if (ObjectFind(LowerLineName)<0)   lower = -1;
   else {
      lower     = ObjectGetValueByShift(LowerLineName,1);
      prevlower = ObjectGetValueByShift(LowerLineName,2);
   }
   
   if (isNewBar()) check_sig(); 
   
   // Trade Decision when both Trendlines are Ready
   // =============================================
   
   if (upper>0 && lower>0)
   {
      if (TradeOutside==True)
      {
         // Price is breaking/leaving UP Linexcutor1
         if ((sig=="Buy_Outside") && (Ask>=openprice) && (Ask<(openprice+Piplimit*point)))
         {
            Alert("Price Breaking UP !!!");
            if (OpenOrd(Magic)==0)   Buy(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==1)
            {  
               CloseOrders(Magic); Sleep(3000);
               Buy(Magic,LotSize,TakeProfit,StopLoss);
            }
         }

         // Price is breaking/leaving DOWN Linexcutor2
         if ((sig=="Sell_Outside") && (Bid<=openprice) && (Ask>(openprice-Piplimit*point)))
         {
            Alert("Price Breaking DOWN !!!");
            if (OpenOrd(Magic)==0)   Sell(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==0)
            {
               CloseOrders(Magic); Sleep(3000); 
               Sell(Magic,LotSize,TakeProfit,StopLoss);
            }
         }
      }
      
      if (TradeInside==True)
      {
         // Price is bouncing Linexcutor1
         if ((sig=="Sell_Inside") && (Bid<=openprice) && (Ask>(openprice-Piplimit*point)))
         {
            Alert("Price Bouncing UPPERline !!!");
            if (OpenOrd(Magic)==0)   Sell(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==0)
            {  
               CloseOrders(Magic); Sleep(3000); 
               Sell(Magic,LotSize,TakeProfit,StopLoss);
            }
         }

         // Price is bouncing Linexcutor2
         if ((sig=="Buy_Inside") && (Ask>=openprice) && (Ask<(openprice+Piplimit*point)))
         {
            Alert("Price Bouncing LOWERline !!!");
            if (OpenOrd(Magic)==0)   Buy(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==1)
            {  
               CloseOrders(Magic); Sleep(3000); 
               Buy(Magic,LotSize,TakeProfit,StopLoss);  
            }
         }       
      }
      }
    if (lTrailingStop > 0) TrailingPositionsBuy();
    if (sTrailingStop > 0) TrailingPositionsSell();    
    if (ScreenDisplay)     checkcomment();             
    return(0);
   }
      
// ------------------------------------------------------------------------------------------ //
//                                 O R D E R S   S T A T U S                                  //
// ------------------------------------------------------------------------------------------ //

int OpenLast(int mgc)
{
   int   last=-1;
      
   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == mgc && OrderSymbol()==s_symbol && OrderType()<=1)
          last = OrderType();
   }      
   return(last);
}

int OpenOrd(int mgc)
{
   int      ord=0;
   
   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == mgc && OrderSymbol()==s_symbol && OrderType()<=1)
          ord++;
   }      
   return(ord);
}

// ------------------------------------------------------------------------------------------ //
//                                 C A L C U L A T E    P I P S                               //
// ------------------------------------------------------------------------------------------ //

int CalcPips(int mgc)
{
   int pips = 0;
   double p = 0;
   
   for (int i=0; i<OrdersTotal(); i++)
   {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if  (OrderMagicNumber()==mgc && OrderSymbol()==s_symbol)
        {
            if (OrderType()==OP_BUY)
            {
               p = (Ask - OrderOpenPrice())*point/Point*point;
               pips = pips + NormalizeDouble(p,0);
            }
            if (OrderType()==OP_SELL)
            {
               p = (OrderOpenPrice() - Bid)*point/Point*point;
               pips = pips + NormalizeDouble(p,0);
            }        
        }
   }   
   return(pips);
}


// ------------------------------------------------------------------------------------------ //
//                              C A L C U L A T E    P R O F I T                              //
// ------------------------------------------------------------------------------------------ //

double CalcProfit(int mgc)
{
   double profit = 0;
   for (int i=0; i<OrdersTotal(); i++)
   {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if  (OrderMagicNumber()==mgc && OrderSymbol()==s_symbol)
             profit = profit + OrderProfit() + OrderSwap();
   }   
return(profit);
}



// ------------------------------------------------------------------------------------------ //
//                                  B U Y   F U N C T I O N                                   //
// ------------------------------------------------------------------------------------------ //

int Buy(int mgc, double lot,  double Tpft, double Slos)
{ 
    int buyTicket = 0;
    int err = 0;
    
    double TP = 0; if (Tpft>0)   TP = NormalizeDouble(Ask + (Tpft*Point*point),digit);
    double SL = 0; if (Slos>0)   SL = NormalizeDouble(Ask - (Slos*Point*point),digit);

    if (IsTradeAllowed() == true)
    {       
       for(int c=0; c<5; c++)
       {
          RefreshRates();
          
          if (!EcnBroker) {
   		       OrderSend(s_symbol,OP_BUY,lot,Ask,Slippage*Point*point,SL,TP,EAcomment, mgc,0,Blue);
   		       sig="BuyEntered";
   		       openprice=0;
   		 }		    
          else
          {
                   buyTicket = OrderSend(s_symbol,OP_BUY,lot,Ask,Slippage*Point*point,0,0,EAcomment, mgc,0,Blue);
                    
                   if (buyTicket >= 0)
                     sig="BuyEntered";
                     openprice=0;
                     OrderModify(buyTicket,OrderOpenPrice(),SL,TP,0,CLR_NONE);
                     if (buyTicket<0) Alert("OpenOrder failed: ", GetLastError());  
                          
                     Print("Errors opening BUY order");
                     Print(ErrorDescription(err),", error ",err);
                     if(err==4 || err==137 ||err==146 || err==136)   {Sleep(5000);continue;} 
                     else  break; //normal error                              // Busy errors
         }
       }
    } 	    
    return(buyTicket);      
}

// ------------------------------------------------------------------------------------------ //
//                                S E L L   F U N C T I O N                                   //
// ------------------------------------------------------------------------------------------ //

int Sell(int mgc, double lot, double Tpft, double Slos)
{    
    int sellTicket = 0;    
    int err = 0;
    
    double TP = 0;if (Tpft>0)   TP = NormalizeDouble(Bid - (Tpft*Point*point),digit);
    double SL = 0;if (Slos>0)   SL = NormalizeDouble(Bid + (Slos*Point*point),digit);

    if (IsTradeAllowed() == true)
    { 
       for(int c=0; c<5; c++)
       { 
         RefreshRates();
         if (!EcnBroker) {
         
   		       OrderSend(s_symbol,OP_SELL,lot,Bid,Slippage*Point*point,SL,TP,EAcomment,mgc,0,Red);
   		       sig="SellEntered";
   		       openprice=0;
   		 }		    		    
          else
          {
                   sellTicket = OrderSend(s_symbol,OP_SELL,lot,Bid,Slippage*Point*point,0,0,EAcomment,mgc,0,Red); 		    
                   if (sellTicket >= 0)
                     sig="SellEntered";
                     openprice=0;
                     OrderModify(sellTicket,OrderOpenPrice(),SL,TP,0,CLR_NONE);
             		   if (sellTicket<0) Alert("OpenOrder failed: ", GetLastError());  
                          
                     Print("Errors opening SELL order");
                     Print(ErrorDescription(err),", error ",err);
                     if(err==4 || err==137 ||err==146 || err==136)   {Sleep(5000);continue;} 
                     else  break; //normal error                              // Busy errors
         }
       }
    } 	    
return(sellTicket);      
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > lTrailingStop * Point * point) { 
                  if (OrderStopLoss() < Bid - lTrailingStop * Point * point) 
                      ModifyStopLoss(Bid    - lTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > sTrailingStop * Point * point) { 
                  if (OrderStopLoss() > Ask + sTrailingStop * Point * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + sTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

// ------------------------------------------------------------------------------------------ //
//                                  C L O S E  O R D E R S                                    //
// ------------------------------------------------------------------------------------------ //

void CloseOrders(int mgc)
{
      int cnt,c,total=0,ticket=0,err=0;
      
      if (IsTradeAllowed() == true)
      { 
       total = OrdersTotal();
       for(cnt=total-1;cnt>=0;cnt--)
       {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

          if(OrderMagicNumber()==mgc && OrderSymbol()==s_symbol)
          {
             switch(OrderType())
             {
                case OP_BUY      :
                   for(c=0;c<5;c++)
                   {
                      RefreshRates();
                      OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage*Point*point,Yellow);
                      err = GetLastError();
                      if (err==0)   break;
                      else
                      {
                         Print("Errors Closing BUY order");
                         Print(ErrorDescription(err),", error ",err);
                         if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                         { Sleep(5000); continue; }                            // Busy errors
                      }
                   }   
                   break;
               
                case OP_SELL     :
                   for(c=0;c<5;c++)
                   {
                      RefreshRates();
                      OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage*Point*point,Yellow);
                      err = GetLastError();
                      if (err==0) break;
                      else
                      {
                         Print("Errors Closing SELL order");
                         Print(ErrorDescription(err),", error ",err);
                         if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                         { Sleep(5000); continue; }                            // Busy errors
                      }
                   }   
                   break;
             } // end of switch
          } // end of if
       } // end of for
      }       
      return(0);
}

bool isNewBar() {
//---- 
   bool res=false;
   if (myBars!=Bars) {
      myBars=Bars;
      res=true;
   }
//----    
   return(res);   
}              

void check_sig() {
//----
   if (TradeOutside==True) {
      if ((Close[1]>upper) && (Close[2]<=prevupper)) {
         sig="Buy_Outside";
         openprice=High[1]+Pipaway*point;
      }
      else if ((Close[1]<lower) && (Close[2]>=prevlower)) {
         sig="Sell_Outside";
         openprice=Low[1]-Pipaway*point;
      }
   }

   if (TradeInside==True) {   
      if ((Close[1]>=lower) && (Close[2]<prevlower)) {
         sig="Buy_Inside";
         openprice=High[1]+Pipaway*point;
      } 
      else if ((Close[1]<=upper) && (Close[2]>prevupper)) {
         sig="Sell_Inside";
         openprice=Low[1]-Pipaway*point;
      } 
   }       
}

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(20093921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(20093922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(20093931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(20093932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(20093941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(20093942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(20093951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(20093961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(20093962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(20093963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(20093964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(20093965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(20093966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(20093967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(20093971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(20093972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(20093973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(20093981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(20093982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(20093983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(20093991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(20093992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(20093993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(20093994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(2009995);
   
return(ManualMagic);
}

//
//
//
//
//

void checkcomment() {
//----
   Comment("\n-----------------------------"+
           "\n-- "+"Current upper trend line value is:  "+DoubleToStr(upper,digit)+ 
           "\n-- "+"Current lower trend line value is:  "+DoubleToStr(lower,digit)+ 
           "\n-- "+"Current signal status is:  "+sig+ 
           "\n-- "+"Target open price for pending order is:  "+DoubleToStr(openprice,digit)+ 
           "\n-- "+"Current order profit in pips:  "+DoubleToStr(CalcPips(Magic),0)+
           "\n-- "+"Current order profit in $$:  "+DoubleToStr(CalcProfit(Magic),2)+
           "\n-----------------------------");
}

// ------------------------------------------------------------------------------------------ //
//                        E N D   O F   E X P E R T   A D V I S O R                           //
// ------------------------------------------------------------------------------------------ //

